#[doc = "Register `CU_IMO_TRIM_USBMODE_24` reader"]
pub struct R(crate::R<CU_IMO_TRIM_USBMODE_24_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<CU_IMO_TRIM_USBMODE_24_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<CU_IMO_TRIM_USBMODE_24_SPEC>> for R {
    fn from(reader: crate::R<CU_IMO_TRIM_USBMODE_24_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `CU_IMO_TRIM_USBMODE_24` writer"]
pub struct W(crate::W<CU_IMO_TRIM_USBMODE_24_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<CU_IMO_TRIM_USBMODE_24_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<CU_IMO_TRIM_USBMODE_24_SPEC>> for W {
    fn from(writer: crate::W<CU_IMO_TRIM_USBMODE_24_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `WR_BG_TRIM5` reader - Trim data"]
pub struct WR_BG_TRIM5_R(crate::FieldReader<u8, u8>);
impl WR_BG_TRIM5_R {
    pub(crate) fn new(bits: u8) -> Self {
        WR_BG_TRIM5_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for WR_BG_TRIM5_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `WR_BG_TRIM5` writer - Trim data"]
pub struct WR_BG_TRIM5_W<'a> {
    w: &'a mut W,
}
impl<'a> WR_BG_TRIM5_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x3f) | (value as u8 & 0x3f);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:5 - Trim data"]
    #[inline(always)]
    pub fn wr_bg_trim5(&self) -> WR_BG_TRIM5_R {
        WR_BG_TRIM5_R::new((self.bits & 0x3f) as u8)
    }
}
impl W {
    #[doc = "Bits 0:5 - Trim data"]
    #[inline(always)]
    pub fn wr_bg_trim5(&mut self) -> WR_BG_TRIM5_W {
        WR_BG_TRIM5_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "PSoC4AL CU IMO TRIM1 24 MHz\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [cu_imo_trim_usbmode_24](index.html) module"]
pub struct CU_IMO_TRIM_USBMODE_24_SPEC;
impl crate::RegisterSpec for CU_IMO_TRIM_USBMODE_24_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [cu_imo_trim_usbmode_24::R](R) reader structure"]
impl crate::Readable for CU_IMO_TRIM_USBMODE_24_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [cu_imo_trim_usbmode_24::W](W) writer structure"]
impl crate::Writable for CU_IMO_TRIM_USBMODE_24_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets CU_IMO_TRIM_USBMODE_24 to value 0"]
impl crate::Resettable for CU_IMO_TRIM_USBMODE_24_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
